#!/usr/bin/env python
"""\
Connect to the local bzr server, and send it commands.
"""

import os
import socket
import struct

def _writestr(f, s):
    f.sendall(struct.pack('>I', len(s)))
    f.sendall(s)

def _readstr(f):
    bytes = struct.unpack('>I', f.recv(4))[0]
    return f.recv(bytes)

def main(argv):
    s = socket.socket()
    s.connect(('localhost', 11111))

    _writestr(s, os.path.realpath(os.getcwd()))

    s.sendall(struct.pack('>I', len(argv)))
    for arg in argv:
        _writestr(s, arg)

    retcode = int(struct.unpack('>I', s.recv(4))[0])
    stdout_and_err = _readstr(s)

    sys.stdout.write(stdout_and_err)
    return retcode

if __name__ == '__main__':
    import sys
    sys.exit(main(sys.argv[1:]))

